from src.variables.service import get_variable, set_variable
from gpiozero import Button
import datetime

#from scripts.speed_controller import rpm_control

pulses_per_rotation = 4
reader = Button(4, pull_up=False, bounce_time=0.0005)
set_variable("speed_reader_last_impulse_time", datetime.datetime.now(), False)
set_variable("actual_rpm_unfiltered", 0, False)


def event():
    actual = datetime.datetime.now()
    last = get_variable("speed_reader_last_impulse_time")
    difference = (actual - last).total_seconds()
    set_variable("speed_reader_last_impulse_time", actual, False)

    rpm = (60 / difference) / pulses_per_rotation
    
    actual_rpm = (float(get_variable("actual_rpm_unfiltered")) + rpm) / 2
    set_variable("actual_rpm_unfiltered", rpm, False)

    set_variable("actual_rpm", round(actual_rpm, 1), False)
    print(round(actual_rpm, 1))
#    rpm_control()
    




reader.when_pressed = event
